<?php

namespace TekNutri\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class ServicosContratados {

    public function __construct($crudService, $connection) {
        $this->crudService = $crudService;
        $this->connection = $connection;
    }
    
    public function retornarOrganizacoes(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $this->dataSourceName = "organizacao";
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, array());
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function verificarRegistros($request, $response){
        $organizacao = $request->getRow()['NRORGINT'];
        try {
            $query = "SELECT * FROM REMPRODNUTR WHERE NRORGINT = :NRORGINT";
            $stmt = $this->connection->prepare($query);
            $params = array(
                "NRORGINT" => $organizacao
            );
            $stmt->execute($params);
            $registros = $stmt->fetchAll(\PDO::FETCH_ASSOC);
            $response->addDataSet(new DataSet("registros", $registros));
	    }catch (\Exception $e) {
	        throw new \Exception($e->getMessage());
	    }
    }
}