/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EQUIPAMENTO                                              */
/* Tabela : EQUIPAMENTO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 08/10/2003 -  Eduardo Henrique                                             */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_EQUIPAMENTO
BEFORE INSERT OR UPDATE OR DELETE
ON EQUIPAMENTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEQUI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.SGEQUIP,0) <> NVL(:NEW.SGEQUIP,0)) OR
         (NVL(:OLD.CDEQUIP,0) <> NVL(:NEW.CDEQUIP,0)) OR
         (NVL(:OLD.DSEQUIP,0) <> NVL(:NEW.DSEQUIP,0)) THEN
         :NEW.DTULTATUEQUI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EQUIPAMENTO', '', 'CDEQUIP='||:OLD.CDEQUIP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EQUIPAMENTO MODIFY DTULTATUEQUI DEFAULT SYSDATE
/
